<?php
/*-------------------------------------------------------+ 
| Class: mmti_image 
| File: image.class.php 
| Last update: 30/09/2008 
+--------------------------------------------------------+ 
| Infusion: MM Team Infusion
| Authors: Michel van Es (MvE Designs), MysticFire
| http://www.mvedesigns.eu (MvE Designs)
| http://www.codaddicts.com (MysticFire)
+--------------------------------------------------------+ 
| PHP-Fusion Content Management System 
| Copyright  2002 - 2008 Nick Jones 
| http://www.php-fusion.co.uk/ 
+--------------------------------------------------------+ 
| This program is released as free software under the 
| Affero GPL license. You can redistribute it and/or 
| modify it under the terms of this license which you 
| can read by viewing the included agpl.txt or online 
| at www.gnu.org/licenses/agpl.html. Removal of this 
| copyright header is strictly prohibited without 
| written permission from the original author(s). 
+--------------------------------------------------------*/
class mmti_image extends mmti_settings
{
    // Variabele(n) 
    var $max_width;
    var $max_height;
    var $max_size;
    var $image=array();
    
    /**
    * Functie: getMax_width 
    * Doel: Ophalen waarde van variabele $max_width 
    **/
    function getMax_width()
    {
      return $this->max_width;
    }
    
    /**
    * Functie: setMax_width 
    * Doel: Toewijzen waarde aan variabele $max_width 
    **/
    function setMax_width($value)
    {
      $this->max_width = $value;
    }
    
    /**
    * Functie: getMax_height 
    * Doel: Ophalen waarde van variabele $max_height 
    **/
    function getMax_height()
    {
      return $this->max_height;
    }
    
    /**
    * Functie: setMax_height 
    * Doel: Toewijzen waarde aan variabele $max_height 
    **/
    function setMax_height($value)
    {
      $this->max_height = $value;
    }
    
    /**
    * Functie: getMax_size 
    * Doel: Ophalen waarde van variabele $max_size 
    **/
    function getMax_size()
    {
      return $this->max_size;
    }
    
    /**
    * Functie: setMax_size 
    * Doel: Toewijzen waarde aan variabele $max_size 
    **/
    function setMax_size ($value)
    {
      $this->max_size  = $value;
    }  
    
    // Dit is de constructor
    function mmti_image()
    {
      $this->__construct();
      register_shutdown_function(array($this,"__destruct"));
    }
    
    // Initialiseer hier alle variabelen
    function __construct()
    {
      parent::__construct();
      $this->setMax_width($this->getImage_w());
      $this->setMax_height($this->getImage_h());
      $this->setMax_size($this->getImage_max_s());
      $this->image['types'] = array("image/pjpeg","image/jpeg","image/gif","image/png","image/x-png" );
      $this->image['extensions'] = array(".jpg",".jpeg",".gif",".png");
      $this->image['destination'] = INFUSIONS."mm_team_panel/images/member/";
    }
    
    // Dit is de destructor
    function __destruct()
    {
      parent::__destruct();
      $this->setMax_width("");
      $this->setMax_height("");
      $this->setMax_size("");
    }

    /**
    * Functie: update_db 
    * Doel: Opslaan van bestandsnaam van image in database 
    **/
    function update_db($user_id=0,$new_image="")
    {
      if(!empty($user_id))
      {
        if($result = dbquery("
          UPDATE ".DB_MM_TEAM_USERS." 
          SET tm_image='".$new_image."' WHERE tm_user_id ='".$user_id."'")) 
        { return true; } else return false;
      } return false;
    }
    
    /**
    * Functie: upload 
    * Doel: Valideren en uploaden afbeelding, verwijderd eerder uploaded afbeelding 
    **/
    function upload($user_id=0,$file=array(),$old_image="")
    {
      $errorlev=0;
    	if (is_uploaded_file($file['tmp_name'])) {
    	  $this->image['file_type'] = $file['type'];
    		$this->image['file_name'] = strtolower(substr($file['name'], 0, strrpos($file['name'], ".")));
    		$this->image['file_extension'] = strtolower(strrchr($file['name'],"."));
    		$this->image['file_size'] = $file['size'];
    		$this->image['image_size'] = getimagesize($file['tmp_name']);
    		$this->image['tmp_name'] = $file['tmp_name'];
    		$this->image['user_image'] = $this->image['destination'].$this->image['file_name']."[".$user_id."]".$this->image['file_extension']; 
    		
    		if($this->validate_name())
    		{
    			if($this->validate_type())
    			{
            if($this->validate_extension())
            {
              if($this->validate_file_size())
              {
                if($this->validate_image_size())
                {
                  if(!verify_image($this->image['tmp_name']))
                  { return $errorlev=6; } else 
                  {
                    if($this->image_exists($old_image)) unlink($this->image['destination'].$old_image);
                    move_uploaded_file($this->image['tmp_name'], $this->image['user_image']);
                    chmod($this->image['user_image'], 0644);
                    if($this->update_db($user_id,$this->image['file_name']."[".$user_id."]".$this->image['file_extension']))
                    { return $errorlev=0; } else return $errorlev=7;                                      
                  }
                } else return $errorlev=5;
              } else return $errorlev=4;
            } else return $errorlev=3;
          } else return $errorlev=2;      
        } else return $errorlev=1;
    	}
    }
    
    /**
    * Functie: delete 
    * Doel: Verwijder image van server gekoppeld aan member 
    **/
    function delete($user_id=0,$image="")
    {
      if(!empty($user_id) && $this->image_exists($image))
      {
        if($result = dbquery("
          UPDATE ".DB_MM_TEAM_USERS." 
          SET tm_image='' WHERE tm_user_id ='".$user_id."'")) 
        {
          unlink($this->image['destination'].$image);return true;
        } else return false;
      } return false;
    }

    /**
    * Functie: dropPictures 
    * Doel: Afbeelding van team members verwijderen ten gevolge van het droppen van de team 
    **/
    function dropPictures()
    {
      $blnError=array();
      $result = dbquery("SELECT tm_user_id,tm_image FROM ".DB_MM_TEAM_USERS);
      if (dbrows($result)) {
     		while ($data = dbarray($result)) {
          $blnError[]=$this->delete($data['tm_user_id'],$data['tm_image']);
        }      
      }
      return (in_array(false,$blnError) ? false : true );    
    }
    
    /**
    * Functie: validate_type 
    * Doel: Afbeelding valideren op geldigheid van bestandstype 
    **/
    function validate_type()
    {
        return (in_array($this->image['file_type'] , $this->image['types']) ? true : false );
    }

    /**
    * Functie: validate_name 
    * Doel: Afbeelding valideren op geldigheid van bestandsnaam
    **/
    function validate_name()
    {
        return (preg_match("/^[-0-9A-Z_\[\]]+$/i", $this->image['file_name']) ? true : false );
    }    
    
    /**
    * Functie: validate_file_size 
    * Doel: Afbeelding valideren op geldigheid van bestandsgrootte 
    **/
    function validate_file_size()
    {
        return ($this->image['file_size'] > ($this->getMax_size()*1024) ? false : true );               
    }

    /**
    * Functie: validate_file_size 
    * Doel: Afbeelding valideren op geldigheid van grootte 
    **/
    function validate_image_size()
    {
        return ($this->image['image_size']['0'] > $this->getMax_width() || $this->image['image_size']['1'] > $this->getMax_height() ? false : true );               
    }
        
    /**
    * Functie: validate_extension 
    * Doel: Afbeelding valideren op geldigheid bestandsextensie 
    **/
    function validate_extension()
    {
        return (in_array($this->image['file_extension'] , $this->image['extensions']) ? true : false );    
    }
    
    /**
    * Functie: image_exists
    * Doel: Controle op bestaan van image 
    **/
    function image_exists($image)
    {
        return (file_exists($this->image['destination'].$image) ? true : false );
    }    
}
?>