<?php
/*-------------------------------------------------------+
| Class: mmti_users
| File: members.class.php
| Last update: 20/dec/2008
+--------------------------------------------------------+
| Infusion: MM Team Infusion
| Authors: Michel van Es (MvE Designs), MysticFire
| http://www.mvedesigns.eu (MvE Designs)
| http://www.codaddicts.com (MysticFire)
+--------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
class mmti_users
{ 
  // Variabele(n) 
  var $tm_id;
  var $tm_user_id;
  var $tm_status;
  var $tm_image;
  var $tm_info;

  /**
  * Functie: getGroupsByMemberID
  * Doel: Ophalen user groups van lid, retourneerd naam van de groep of false indien lid niet bestaat
  **/
  function getGroupsByMemberID($user_id=0)
  {
    $result = dbquery("SELECT user_groups FROM ".DB_USERS." WHERE user_id='".$user_id."'");         
    if (dbrows($result) != 0) { $data = dbarray($result); return $data['user_groups']; } else return false;
  }

  /**
  * Functie: getLevelByMemberID
  * Doel: Ophalen user level van lid, retourneerd level of false indien lid niet bestaat
  **/
  function getLevelByMemberID($user_id=0)
  {
    $result = dbquery("SELECT user_level FROM ".DB_USERS." WHERE user_id='".$user_id."'");         
    if (dbrows($result) != 0) { $data = dbarray($result); return $data['user_level']; } else return false;
  }
  
  /**
  * Functie: userExists
  * Doel: Controle op bestaan van php-fusion lid, retourneerd naam van lid of false indien lid niet bestaat
  **/
  function userExists($user_id=0)
  {
    $result = dbquery("SELECT user_name FROM ".DB_USERS." WHERE user_id='".$user_id."'");     
    if (dbrows($result) != 0) { $data = dbarray($result); return $data['user_name']; } else return false;
  }

  /**
  * Functie: memberExists
  * Doel: Controle op bestaan van team lid, retourneerd true of false
  **/  
  function memberExists($user_id=0)
  {
    $result = dbquery("SELECT tm_id FROM ".DB_MM_TEAM_USERS." WHERE tm_user_id='".$user_id."'");     
    if (dbrows($result) != 0) { return true; } else return false;  
  }
  
    /**
    * Functie: qryMembers
    * Doel: Ophalen team members en deze query retourneren
    **/  
    function qryMembers($team_id=0,$rowstart=0,$itemspp=0)
    {
        $result = dbquery("SELECT user_id,user_name,user_web,user_email,user_hide_email,user_lastvisit FROM ".DB_USERS." WHERE user_groups REGEXP('^\\\.{$team_id}$|\\\.{$team_id}\\\.|\\\.{$team_id}$') ORDER BY user_level DESC, user_name LIMIT {$rowstart},".$itemspp."");
        return $result;  
    }

    /**
    * Functie: qryActiveMembers
    * Doel: Ophalen actieve team members en deze query retourneren
    **/  
    function qryActiveMembers($team_id=0,$rowstart=0,$itemspp=0)
    {
        //$result = dbquery("SELECT user_id,user_name,user_web,user_email,user_hide_email,user_lastvisit FROM ".DB_USERS." WHERE user_groups REGEXP('^\\\.{$team_id}$|\\\.{$team_id}\\\.|\\\.{$team_id}$') ORDER BY user_level DESC, user_name LIMIT {$rowstart},".$itemspp."");
        $result = dbquery("
            SELECT user_id,user_name,user_web,user_email,user_hide_email,user_lastvisit 
            FROM ".DB_USERS." u
            LEFT JOIN ".DB_MM_TEAM_USERS." t ON (u.user_id = t.tm_user_id)
            WHERE user_groups REGEXP('^\\\.{$team_id}$|\\\.{$team_id}\\\.|\\\.{$team_id}$') AND t.tm_status = 1
            ORDER BY user_level DESC, user_name LIMIT {$rowstart},".$itemspp."");
        return $result;  
    }

  /**
  * Functie: countProfiles
  * Doel: Retour, aantal actieve team profiles
  **/  
  function countProfiles($team_id=0)
  {
    $result = dbquery("
         SELECT count(tm_user_id)
         FROM ".DB_MM_TEAM_USERS."
         LEFT JOIN ".DB_USERS." u ON (tm_user_id = u.user_id)
         WHERE u.user_groups REGEXP('^\\\.{$team_id}$|\\\.{$team_id}\\\.|\\\.{$team_id}$') AND tm_status = 1");
    $rows = mysql_result($result, 0);
    return $rows;    
  }    

  /**
  * Functie: isTeamMember
  * Doel: Controle op lid van team, boolean waarde retour
  **/  
  function isTeamMember($team_id=0)
  {
    if (in_array($team_id, explode(".", iUSER_GROUPS)))
    { return true; } else return false;  
  }
  
  /**
  * Functie: loadMemberByID
  * Doel: Ophalen gegevens team member o.b.v. variabele $user_id
  **/  
  function loadMemberByID($user_id=0) 
  {
    $result = dbquery("SELECT * FROM ".DB_MM_TEAM_USERS." WHERE tm_user_id='".$user_id."' LIMIT 1");
    if (dbrows($result)) {
   		while ($data = dbarray($result)) {
        $this->setTm_id($data['tm_id']);
        $this->setTm_user_id($data['tm_user_id']);
        $this->setTm_status($data['tm_status']);
        $this->setTm_image($data['tm_image']);
        $this->setTm_info($data['tm_info']);
      }      
    } else {
      $this->setTm_id("");
      $this->setTm_user_id($user_id);
      $this->setTm_status("");
      $this->setTm_image("");
      $this->setTm_info("");
    }
  }

  /**
  * Functie: getMemberStatus
  * Doel: Retourneren status van team lid in de vorm van een afbeelding o.b.v. variabele $user_id
  **/
  function getMemberStatus($user_id=0)
  {
    global $locale;
    $result = dbquery("SELECT tm_status FROM ".DB_MM_TEAM_USERS." WHERE tm_user_id ='".$user_id."'");
    if (dbrows($result) != 0) {
      $data = dbarray($result);
      if($data['tm_status'] == '1') {
        return INFUSIONS."mm_team_panel/images/active.gif' alt='".$locale['MMTI_113'];
      }elseif($data['tm_status'] == '2') {
        return INFUSIONS."mm_team_panel/images/disabled.gif' alt='".$locale['MMTI_115'];
      }else return INFUSIONS."mm_team_panel/images/inactive.gif' alt='".$locale['MMTI_114'];
    } else return INFUSIONS."mm_team_panel/images/inactive.gif' alt='".$locale['MMTI_114'];  
  }  

  /**
  * Functie: getMemberStatus
  * Doel: Retourneren status van team lid in de vorm van een afbeelding o.b.v. variabele $user_id
  **/
  function getUserStatusImage($user_lastvisit="")
  {
    $lastseen = time() - $user_lastvisit;
    if($lastseen < 60) {
    	return "<img src='".INFUSIONS."mm_team_panel/images/online.png' width='50' height='50' border='0'></a>";
    } else {
    	return "<img src='".INFUSIONS."mm_team_panel/images/offline.png' width='50' height='50' border='0'></a>";
    } 
  }

  /**
  * Functie: getProfileStatus
  * Doel: Retourneren status van profiel team lid
  **/
  function getProfileStatus()
  {
    return ($this->tm_status==1 ? true : false); //Alleen met status actief    
  }

  /**
  * Functie: getUserWeb
  * Doel: Retour: web adres van member
  **/
  function getUserWeb($user_web="")
  {
    if (!empty($user_web)) {
    	$urlprefix = !strstr($user_web, "http://") ? "http://" : "";
    	$website = "<a href='".$urlprefix.$user_web."' target='_blank'>";
    	$website.= "<img src='".INFUSIONS."mm_team_panel/images/www.png' border='0' alt='".$urlprefix.$user_web."'></a>";
    	return $website;
    }  
  }

  /**
  * Functie: getUserPM
  * Doel: Retour: send pm link van member
  **/
  function getUserPM($user_id=0)
  {
    global $locale;
    	$user_pm = "<a href='".BASEDIR."messages.php?msg_send=".$this->getTm_user_id()."'>";
    	$user_pm.= "<img src='".INFUSIONS."mm_team_panel/images/pm.png' border='0' alt='".$locale['MMTI_311']."'></a>";
    	return $user_pm;
  }

  /**
  * Functie: getUserEmail
  * Doel: Retour: e-mail adres van member indien niet verborgen of wanneer admin
  **/  
  function getUserEmail($user_email="",$user_hide_email=1)
  {
    if ($user_hide_email != "1" || iADMIN) 
    {
      $email = "<a href='mailto:".$user_email."'>";
      $email.= "<img src='".INFUSIONS."mm_team_panel/images/email.png' border='0' alt='".$user_email."'></a>";
      return $email;
    } 
  }
  
  /**
  * Functie: setMemberStatus
  * Doel: Instellen status van team lid o.b.v. de variabelen $user_id en $status, retourneerd boolean waarde
  **/ 
  function setMemberStatus($status=0,$user_id=0)
  {
    if($result = dbquery("
      UPDATE ".DB_MM_TEAM_USERS." 
      SET tm_status='".$status."' WHERE tm_user_id ='".$user_id."'")) 
      { return true; } else return false;  
  }

  /**
  * Functie: updateMember
  * Doel: Instellen info van team lid o.b.v. de variabelen $member_info en $user_id, retourneerd boolean waarde
  **/ 
  function updateMember($member_info="",$user_id=0)
  {
    if($result = dbquery("
      UPDATE ".DB_MM_TEAM_USERS." 
      SET tm_info='".$member_info."' WHERE tm_user_id ='".$user_id."'")) 
      { return true; } else return false;  
  }

  /**
  * Functie: insertMember
  * Doel: Toevoegen van team lid o.b.v. de variabelen $member_info en $user_id, retourneerd boolean waarde
  **/  
  function insertMember($member_info="",$user_id=0)
  {
    if($result = dbquery("INSERT INTO ".DB_MM_TEAM_USERS." (tm_user_id, tm_info) VALUES ('".$user_id."', '".$member_info."')")) 
    { return true; } else return false;  
  }  
  
  /**
  * Functie: getTm_id
  * Doel: Ophalen waarde van variabele $tm_id
  **/
  function getTm_id()
  {
        return $this->tm_id;
  }
  
  /**
  * Functie: setTm_id
  * Doel: Toewijzen waarde aan variabele $tm_id
  **/
  function setTm_id($value)
  {
        $this->tm_id = $value;
  }
  
  /**
  * Functie: getTm_user_id
  * Doel: Ophalen waarde van variabele $tm_user_id
  **/
  function getTm_user_id()
  {
        return $this->tm_user_id;
  }
  
  /**
  * Functie: setTm_user_id
  * Doel: Toewijzen waarde aan variabele $tm_user_id
  **/
  function setTm_user_id($value)
  {
        $this->tm_user_id = $value;
  }
 
  /**
  * Functie: getTm_status
  * Doel: Ophalen waarde van variabele $tm_status
  **/
  function getTm_status($admin=false)
  {
    global $locale,$aidlink;
    $Fusion_Self = ($admin ? FUSION_SELF.$aidlink."&amp;" : FUSION_SELF."?");
    $_GET['rowstart'] = (isset($_GET['rowstart']) && isNum($_GET['rowstart'])) ? $_GET['rowstart'] : 0;  
    switch ($this->tm_status) {
      case "1":
          $status = $locale['MMTI_113']." (<a href='".$Fusion_Self."rowstart=".$_GET['rowstart']."&amp;action=deactivate&amp;id=".$this->getTm_user_id()."' onclick='return deactivate_memberinfo();'>".$locale['MMTI_117']."</a>";
          if($admin) $status .= " &#45; <a href='".$Fusion_Self."rowstart=".$_GET['rowstart']."&amp;action=disable&amp;id=".$this->getTm_user_id()."' onclick='return disable_memberinfo();'>".$locale['MMTI_108']."</a>";
          $status .= ")";break;
      case "2":
          $status = "<span style='color: red'>".$locale['MMTI_435']."</span>";
          if($admin) $status = $locale['MMTI_115']." (<a href='".$Fusion_Self."rowstart=".$_GET['rowstart']."&amp;action=enable&amp;id=".$this->getTm_user_id()."' onclick='return enable_memberinfo();'>".$locale['MMTI_109']."</a>)";break;        
      case "0":
          $status = $locale['MMTI_114']." (<a href='".$Fusion_Self."rowstart=".$_GET['rowstart']."&amp;action=activate&amp;id=".$this->getTm_user_id()."' onclick='return activate_memberinfo();'>".$locale['MMTI_116']."</a>";
          if($admin) $status .= " &#45; <a href='".$Fusion_Self."rowstart=".$_GET['rowstart']."&amp;action=disable&amp;id=".$this->getTm_user_id()."' onclick='return disable_memberinfo();'>".$locale['MMTI_108']."</a>";
          $status .= ")";break;
      default:
          $status="";
          if($admin) 
          { 
            $status = $locale['MMTI_428'];
          } else { $status = $locale['MMTI_438']; }                
    }
    return $status;
  }
  
  /**
  * Functie: setTm_status
  * Doel: Toewijzen waarde aan variabele $tm_status
  **/
  function setTm_status($value)
  {
        $this->tm_status = $value;
  }
  
  /**
  * Functie: getTm_image
  * Doel: Ophalen waarde van variabele $tm_image, retourneren van team lid afbeelding
  **/
  function getTm_image($blnEdit=false)
  {
    if($this->tm_image!= "" && file_exists(INFUSIONS."mm_team_panel/images/member/".$this->tm_image)) {
    	$show_image = "<img src='".INFUSIONS."mm_team_panel/images/member/".$this->tm_image."' alt='".$this->tm_image."'>";
    }	else {
      if($blnEdit==true || !$this->getUser_avatar())
      {
         $show_image = "<img src='".INFUSIONS."mm_team_panel/images/member/noimage.gif'>";
      } else {
         $show_image = "<img src='".IMAGES."avatars/".$this->getUser_avatar()."'>";
      }
    }
    return $show_image;  
  }

  /**
  * Functie: getUser_avatar
  * Doel: Ophalen waarde van db veld user_avatar
  **/
  function getUser_avatar()
  {
    $result = dbquery("SELECT user_avatar FROM ".DB_USERS." WHERE user_id='".$this->tm_user_id."' LIMIT 1");
      if(dbrows($result) != 0) {
        $data = dbarray($result);
        if(!EMPTY($data['user_avatar']) && file_exists(IMAGES."avatars/".$data['user_avatar'])) 
        {
            return $data['user_avatar'];
        } else {
           return false;
        }   
      } else return false;
  }
  
  /**
  * Functie: setTm_image
  * Doel: Toewijzen waarde aan variabele $tm_image
  **/
  function setTm_image($value)
  {
        $this->tm_image = $value;
  }
  
  /**
  * Functie: getTm_info
  * Doel: Ophalen waarde van variabele $tm_info
  **/
  function getTm_info()
  {
        return $this->tm_info;
  }
  
  /**
  * Functie: setTm_info
  * Doel: Toewijzen waarde aan variabele $tm_info
  **/
  function setTm_info($value)
  {
        $this->tm_info = $value;
  }
  
  // Dit is de constructor
  function mmti_users()
  {
        $this->__construct();
        register_shutdown_function(array($this,"__destruct"));
  }
  
  // Initialiseer hier alle variabelen
  function __construct()
  {
        $this->setTm_id("");
        $this->setTm_user_id("");
        $this->setTm_status("");
        $this->setTm_image("");
        $this->setTm_info("");
  }
  
  // Dit is de destructor
  function __destruct()
  {
        $this->setTm_id("");
        $this->setTm_user_id("");
        $this->setTm_status("");
        $this->setTm_image("");
        $this->setTm_info("");
  }
} 
?>