<?php
/*-------------------------------------------------------+
| Class: mmti_status_msg
| Purpose: Displays admin message based on $_GET['status']
| Date: 05-oct-2008
+--------------------------------------------------------+
| Infusion: MM Team Infusion
| Authors: Michel van Es (MvE Designs), MysticFire
| http://www.mvedesigns.eu (MvE Designs)
| http://www.codaddicts.com (MysticFire)
+--------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
class mmti_status_msg
{ 
   // Variabele(n) 
   var $status ;
   var $message;
    
   /**
   * Functie: getStatus 
   * Doel: Ophalen waarde van variabele $status 
   **/
   function getStatus()
   {
      return $this->status ;
   }
   
   /**
   * Functie: setStatus 
   * Doel: Toewijzen waarde aan variabele $status en $message 
   **/
   function setStatus($value)
   {
     global $locale;
      $this->status  = $value;
      switch ($this->getStatus()) {
       case "tass": // User Group Assigned as Team
           $this->setMessage($locale['MMTI_410']);break;
       case "tnass": // User Group could not be assigned as Team
           $this->setMessage($locale['MMTI_411']);break;
       case "tdro": // User Group as Team dropped
           $this->setMessage($locale['MMTI_412']);break;
       case "tndro": // User Group as Team could not be dropped
           $this->setMessage($locale['MMTI_413']);break;
       case "pndro": // User images could not (all)be dropped
           $this->setMessage($locale['MMTI_437']);break;
       case "tadd": //User Group added as Team
           $this->setMessage($locale['MMTI_414']);break;
       case "tnadd": // User Group could not be added as Team
           $this->setMessage($locale['MMTI_415']);break;
       case "tset": // Team Settings updated
           $this->setMessage($locale['MMTI_416']);break;
       case "tnset": // Team Settings could not be updated
           $this->setMessage($locale['MMTI_417']);break;
       case "mupd": // Member Profile updated
           $this->setMessage($locale['MMTI_418']);break;
       case "mnupd": // Member Profile could not be updated
           $this->setMessage($locale['MMTI_419']);break;
       case "mena": // Member Profile enabled
           $this->setMessage($locale['MMTI_420']);break;
       case "mnena": // Member Profile could not be enabled
           $this->setMessage($locale['MMTI_421']);break;
       case "mact": // Member Profile activated
           $this->setMessage($locale['MMTI_422']);break;
       case "mnact": // Member Profile could not be activated
           $this->setMessage($locale['MMTI_423']);break;
       case "mdis": // Member Profile disabled
           $this->setMessage($locale['MMTI_424']);break;
       case "mndis": // Member Profile could not be disabled
           $this->setMessage($locale['MMTI_425']);break;
       case "mdea": // Member Profile deactivated
           $this->setMessage($locale['MMTI_426']);break;
       case "mndea": // Member Profile could not be deactivated
           $this->setMessage($locale['MMTI_427']);break;
       case "iin": // Invalid image name
           $this->setMessage($locale['MMTI_450']);break;
       case "ift": // Invalid file type
           $this->setMessage($locale['MMTI_451']);break;
       case "ife": // Invalid file extension
           $this->setMessage($locale['MMTI_452']);break;
       case "ifs": // File size exceeded
           $this->setMessage($locale['MMTI_453']);break;
       case "iis": // Image size exceeded
           $this->setMessage($locale['MMTI_454']);break;
       case "imc": // Malicious code found in image
           $this->setMessage($locale['MMTI_455']);break;                                                                                                                              
      }          
   }
   
   /**
   * Functie: getMessage
   * Doel: Ophalen waarde van variabele $message
   **/
   function getMessage()
   {
          return $this->message;
   }
   
   /**
   * Functie: setMessage
   * Doel: Toewijzen waarde aan variabele $message
   **/
   function setMessage($value)
   {
          $this->message = $value;
   }
   
   // Dit is de constructor
   function mmti_status_msg()
   {
          $this->__construct();
          register_shutdown_function(array($this,"__destruct"));
   }
   
   // Initialiseer hier alle variabelen
   function __construct()
   {
          $this->setStatus ("");
          $this->setMessage("");
   }
   
   // Dit is de destructor
   function __destruct()
   {
          $this->setStatus ("");
          $this->setMessage("");
   }
   
   /**
   * Functie: display
   * Doel: Retourneren status bericht 
   **/
   function display()
   {
      if (!empty($this->message)) {	return "<div class='admin-message'>".$this->message."</div>\n"; }
   }
} 
?>