<?php 
/*-------------------------------------------------------+ 
| Class: mmti_team 
| File: team.class.php 
| Last update: 28/09/2008 
+--------------------------------------------------------+ 
| Infusion: MM Team Infusion
| Authors: Michel van Es (MvE Designs), MysticFire
| http://www.mvedesigns.eu (MvE Designs)
| http://www.codaddicts.com (MysticFire)
+--------------------------------------------------------+ 
| PHP-Fusion Content Management System 
| Copyright  2002 - 2008 Nick Jones 
| http://www.php-fusion.co.uk/ 
+--------------------------------------------------------+ 
| This program is released as free software under the 
| Affero GPL license. You can redistribute it and/or 
| modify it under the terms of this license which you 
| can read by viewing the included agpl.txt or online 
| at www.gnu.org/licenses/agpl.html. Removal of this 
| copyright header is strictly prohibited without 
| written permission from the original author(s). 
+--------------------------------------------------------*/
class mmti_team extends mmti_settings
{ 
    // Variabele(n) 
    var $group_id ;
    var $group_name ;
    var $group_description;


    /**
    * Functie: getGroup_id 
    * Doel: Ophalen waarde van variabele $group_id 
    **/
    function getGroup_id()
    {
        return $this->group_id ;
    }

    /**
    * Functie: setGroup_id 
    * Doel: Toewijzen waarde aan variabele $group_id 
    **/
    function setGroup_id($value)
    {
        $this->group_id  = $value;
    }

    /**
    * Functie: getGroup_name 
    * Doel: Ophalen waarde van variabele $group_name 
    **/
    function getGroup_name()
    {
        return $this->group_name ;
    }

    /**
    * Functie: setGroup_name 
    * Doel: Toewijzen waarde aan variabele $group_name 
    **/
    function setGroup_name($value)
    {
        $this->group_name  = $value;
    }

    /**
    * Functie: getGroup_description
    * Doel: Ophalen waarde van variabele $group_description
    **/
    function getGroup_description()
    {
        return $this->group_description;
    }

    /**
    * Functie: setGroup_description
    * Doel: Toewijzen waarde aan variabele $group_description
    **/
    function setGroup_description($value)
    {
        $this->group_description = $value;
    }

    /**
    * Functie: getTeam 
    * Doel: Retourneren waarde group_name
    **/
    function getTeam()
    {
       global $aidlink,$locale;
        $result = dbquery("
         SELECT u.group_name, u.group_id 
         FROM ".DB_MM_TEAM_SETTINGS." i
         LEFT JOIN ".DB_USER_GROUPS." u on (i.group_id = u.group_id)");
        if(dbrows($result) != 0) {
           $data = dbarray($result);
           if(!EMPTY($data['group_name'])) {
              return $data['group_name']." [<a href='".FUSION_SELF.$aidlink."&amp;pagenum=2&amp;action=drop' onclick='return drop_team();'>".$locale['MMTI_102']."</a>]";
           } else {
              return $locale['MMTI_112']." [<a href='".FUSION_SELF.$aidlink."&amp;pagenum=2&amp;action=assign'>".$locale['MMTI_100']."</a> &#45; <a href='".FUSION_SELF.$aidlink."&amp;pagenum=2&amp;action=create'>".$locale['MMTI_101']."</a>]";
           }   
        }
    }

    /**
    * Functie: setTeam 
    * Doel: Instellen Active Team, boolean waarde retour 
    **/
    function setTeam($intGroupID=0)
    {
        if($result = dbquery("UPDATE ".DB_MM_TEAM_SETTINGS." SET group_id='".$intGroupID."'")) 
        { return true; } else return false;
    }

    /**
    * Functie: addTeam 
    * Doel: Toevoegen nieuw gebruikersgroep als team, boolean waarde retour 
    **/
    function addTeam($team_name, $team_description)
    {
        if($result = dbquery("INSERT INTO ".DB_USER_GROUPS." (group_name, group_description) VALUES ('".$team_name."', '".$team_description."')")) 
        { return true; } else return false;
    }

    /**
    * Functie: dropTeam 
    * Doel: Toewijzen waarde 0 aan group_id, wat overeenkomt met het feit er geen Team meer actief staat
    *       Members zullen worden verwijderd
    **/
    function dropTeam()
    {
        $result1 = dbquery("UPDATE ".DB_MM_TEAM_SETTINGS." SET group_id='0'");
        $result2 = dbquery("DELETE FROM ".DB_MM_TEAM_USERS);
        if($result1 && $result2) { return true; } else return false;
    }

    /**
    * Functie: getTeams 
    * Doel: Ophalen gebruikersgroepen 
    **/
    function getTeams()
    {
        $result = dbquery("SELECT * FROM ".DB_USER_GROUPS." ORDER BY group_id ASC");
        if (dbrows($result)) {
        	$arrTeams = array();
        	while ($data = dbarray($result)) {
        		$arrTeams[] = $data;
        	}
        } else {
        	$arrTeams = array();
        }
        return $arrTeams;
    }

    /**
    * Functie: selTeams 
    * Doel: Retourneren gebruikersgroepen voor toevoeging aan <select> element 
    **/
    function selTeams()
    {
        $team_opts="";$arrTeams=$this->getTeams();
        while(list($key, $team) = each($arrTeams)){
          $team_opts .= "<option value='".$team['group_id']."'>".$team['group_name']."</option>\n";
        }
        return $team_opts;
    }

    /**
    * Functie: teamAssigned 
    * Doel: Controle of er een user group is toegewezen als Team 
    **/
    function teamAssigned()
    {
        $result = dbquery("SELECT group_id FROM ".DB_MM_TEAM_SETTINGS." WHERE group_id='0'");
        if(dbrows($result) != 0) { return false; } else return true;
    }

    /**
    * Functie: countMembers
    * Doel: Retour, aantal team members
    **/  
    function countMembers($team_id=0)
    {
      $rows = dbcount("(user_id)", DB_USERS, "user_groups REGEXP('^\\\.{$team_id}$|\\\.{$team_id}\\\.|\\\.{$team_id}$')");
      return $rows;
    }

    // Dit is de constructor
    function mmti_team()
    {
        $this->__construct();
        register_shutdown_function(array($this,"__destruct"));
    }

    // Initialiseer hier alle variabelen
    function __construct()
    {
        parent::__construct();
        $this->setGroup_id($this->group_id);
        $this->setGroup_name("");
        $this->setGroup_description("");
    }

    // Dit is de destructor
    function __destruct()
    {
        parent:: __destruct();
        $this->setGroup_id("");
        $this->setGroup_name("");
        $this->setGroup_description("");
    }
}
?> 