<?php 
/*-------------------------------------------------------+ 
| Class: version_check 
| File: version_check.class.php (PHP5)
| Last update: 21/dec/2008 
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: MM Team Infusion
| Authors: Michel van Es (MvE Designs), MysticFire
| http://www.mvedesigns.eu (MvE Designs)
| http://www.codaddicts.com (MysticFire)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
class version_check
{ 
    // Variabele(n) 
    var $inf_version;
    var $inf_changelog;
    var $inf_download_url;
    var $xml_url;
    var $msg_caption;
    var $msg_download;
    var $msg_changelog;


    /**
    * Functie: getInf_version 
    * Doel: Ophalen waarde van variabele $inf_version 
    **/
    function getInf_version()
    {
        return $this->inf_version;
    }

    /**
    * Functie: setInf_version 
    * Doel: Toewijzen waarde aan variabele $inf_version 
    **/
    function setInf_version ($value)
    {
        $this->inf_version  = $value;
    }

    /**
    * Functie: getInf_changelog 
    * Doel: Ophalen waarde van variabele $inf_changelog 
    **/
    function getInf_changelog()
    {
        return $this->inf_changelog;
    }

    /**
    * Functie: setInf_changelog 
    * Doel: Toewijzen waarde aan variabele $inf_changelog 
    **/
    function setInf_changelog ($value)
    {
        $this->inf_changelog  = $value;
    }

    /**
    * Functie: getInf_download_url 
    * Doel: Ophalen waarde van variabele $inf_download_url 
    **/
    function getInf_download_url()
    {
        return $this->inf_download_url;
    }

    /**
    * Functie: setInf_download_url 
    * Doel: Toewijzen waarde aan variabele $inf_download_url 
    **/
    function setInf_download_url ($value)
    {
        $this->inf_download_url  = $value;
    }

    /**
    * Functie: getXml_url 
    * Doel: Ophalen waarde van variabele $xml_url 
    **/
    function getXml_url()
    {
        return $this->xml_url;
    }

    /**
    * Functie: setXml_url 
    * Doel: Toewijzen waarde aan variabele $xml_url 
    **/
    function setXml_url ($value)
    {
        // Controleer op geldigheid link
        if(parse_url($value, PHP_URL_SCHEME) == "http")
        {
            // Controleer op geldigheid extensie
            $ext = strrpos($value, ".");
            if(substr($value, $ext+1) == "xml")
            {
               $this->xml_url = $value;
            } else $this->xml_url = false;
        } else $this->xml_url = false;
        
    }

    /**
    * Functie: getMsg_caption 
    * Doel: Ophalen waarde van variabele $msg_caption 
    **/
    function getMsg_caption()
    {
        return $this->msg_caption;
    }

    /**
    * Functie: setMsg_caption 
    * Doel: Toewijzen waarde aan variabele $msg_caption 
    **/
    function setMsg_caption ($value)
    {
        $this->msg_caption = (!empty($value)) ? $value : "There is an new update available!" ;
    }

    /**
    * Functie: getMsg_download 
    * Doel: Ophalen waarde van variabele $msg_download 
    **/
    function getMsg_download()
    {
        return $this->msg_download;
    }

    /**
    * Functie: setMsg_download 
    * Doel: Toewijzen waarde aan variabele $msg_download 
    **/
    function setMsg_download ($strMsg, $strDownload)
    {
        $message = (!empty($strMsg) ? $strMsg : " Your current version is not up to date!" );
        $download_link = (!empty($strDownload)) ? $strDownload : "Download here v" ;
           
        $this->msg_download  =  "<span style='color:red;'>".$message." <a href='".$this->getInf_download_url()."' target='_blank'>".$download_link.$this->getInf_version()."</a>.<br /></span>";
    }

    /**
    * Functie: getMsg_changelog
    * Doel: Ophalen waarde van variabele $msg_changelog
    **/
    function getMsg_changelog()
    {
        return $this->msg_changelog;
    }

    /**
    * Functie: setMsg_changelog
    * Doel: Toewijzen waarde aan variabele $msg_changelog
    **/
    function setMsg_changelog($value)
    {
        $message = (!empty($value)) ? $value: "CHANGELOG" ;
        $strHTML = "<span style='text-decoration: underline'>".$message."</span>:";
        $strHTML.= "<div style='text-align:center'><textarea style='width:95%;border:thin groove;' rows='10'>".$this->getInf_changelog()."</textarea></div>"; 
        $this->msg_changelog = $strHTML;
    }
    
    // Dit is de constructor
    function version_check()
    {
        $this->__construct();
        register_shutdown_function(array($this,"__destruct"));
    }

    // Initialiseer hier alle variabelen
    function __construct()
    {
        $this->setInf_version("");
        $this->setInf_changelog("");
        $this->setInf_download_url("");
        $this->setXml_url("");
        $this->setMsg_caption("");
        $this->setMsg_download("","");
        $this->setMsg_changelog("");
    }

    // Dit is de destructor
    function __destruct()
    {
        $this->setInf_version("");
        $this->setInf_changelog("");
        $this->setInf_download_url("");
        $this->setXml_url("");
        $this->setMsg_caption("");
        $this->setMsg_download("","");
        $this->setMsg_changelog("");
    }
    /**
    * Functie: load_xml 
    * Doel: Inladen en retourneren xml bestand indien bestaat 
    **/
    function load_xml()
    {
      if($this->check_file_exists())
      {
         $xml = simplexml_load_file($this->getXml_url());
         return $xml;         
      } else return false;
    }

    /**
    * Functie: check_version
    * Doel: Controle op aanwezigheid laatste versie 
    **/
    function check_version($current_version)
    {
      if($current_version < $this->getInf_version())
      {
         openside($this->getMsg_caption(),true,"off");
            echo "<div class='admin-message'>";
            echo $this->getMsg_download();
            echo $this->getMsg_changelog();
            echo "</div>\n";
         closeside();
      }
    }

    /**
    * Functie: check_file_exists
    * Doel: Controle op bestaan opgegeven url middels var setXml_url
    **/
    function check_file_exists()
    {
        if(@fopen($this->getXml_url(), "r")) {
            return true;
        } else return false;
    }
}
?> 